﻿using System;
using System.IO;

/*
 *  ChangeCreated - Erstellzeit von Dateien auslesen und setzen
 * 
 *      erstellt am 18. Juli 2009
 *      von Stefan Diewald (stefan.diewald@diewie.net)
 * 
 */

namespace changecreated
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] valid_params = {"-s", "-ss", "-g", "-o", "-os", "-h"};

            if (args.Length >= 1 && (Array.Exists(valid_params, s => s == args[0])))
            {
                DateTime newDate;

                switch (args[0]) {
                    case "-s":
                    case "-ss":
                        if (args.Length >= 3)
                        {
                            if (File.Exists(args[1]))
                            {
                                try
                                {
                                    string strDate = "";
                                    for (int i = 2; i <= args.Length - 1; i++)
                                    {
                                        strDate += " " + args[i];
                                    }
                                    strDate = strDate.Trim();
                                    newDate = DateTime.Parse(strDate);
                                    File.SetCreationTime(args[1], newDate);
                                    if (args[0] == "-s")
                                    {
                                        Console.WriteLine("Neues Erstellungsdatum: " + File.GetCreationTime(args[1]));
                                    }
                                }
                                catch (Exception e)
                                {
                                    Console.WriteLine("Kann Datum nicht einlesen: " + e.Message);
                                    Environment.Exit(1);
                                }
                            }
                            else
                            {
                                Console.WriteLine("Fehler: Datei \"" + args[1] + "\" nicht gefunden.");
                                Console.WriteLine(help());
                                Environment.Exit(1);
                            }
                        }
                        else
                        {
                            Console.WriteLine("Fehler: 2 weitere Parameter notwendig");
                            Console.WriteLine(help());
                            Environment.Exit(1);
                        }
                        break;
                    case "-o":
                    case "-os":
                        if (args.Length >= 3)
                        {
                            if (File.Exists(args[1]) && File.Exists(args[2]))
                            {
                                try
                                {
                                    File.SetCreationTime(args[2], File.GetCreationTime(args[1]));
                                    if (args[0] == "-o")
                                    {
                                        Console.WriteLine("Erstellungsdatum übernommen: " + File.GetCreationTime(args[2]));
                                    }
                                }
                                catch (Exception e)
                                {
                                    Console.WriteLine("Fehler bei Datumsübernahme: " + e.Message);
                                    Environment.Exit(1);
                                }
                            }
                            else
                            {
                                if (!File.Exists(args[1]))
                                    Console.WriteLine("Fehler: Datei \"" + args[1] + "\" nicht gefunden.");
                                if (!File.Exists(args[2]))
                                    Console.WriteLine("Fehler: Datei \"" + args[2] + "\" nicht gefunden.");
                                Console.WriteLine(help());
                                Environment.Exit(1);
                            }
                        }
                        else
                        {
                            Console.WriteLine("Fehler: 2 weitere Parameter notwendig");
                            Console.WriteLine(help());
                            Environment.Exit(1);
                        }
                        break;
                    case "-h":
                        Console.WriteLine(help());
                        Environment.Exit(1);
                        break;
                    case "-g":
                    default:
                        if (File.Exists(args[1]))
                        {
                            Console.WriteLine(File.GetCreationTime(args[1]));
                        }
                        else
                        {
                            Console.WriteLine("Fehler: Datei \"" + args[1] + "\" nicht gefunden.");
                            Console.WriteLine(help());
                            Environment.Exit(1);
                        }
                        break;
                    
                }
            }
            else
            {
                if (args.Length == 0)
                    Console.WriteLine("Fehler: Kein Parameter gefunden");
                else
                    Console.WriteLine("Fehler: Parameter " + args[0] + " ist unbekannt");
                Console.WriteLine(help());
                Environment.Exit(1);
            }
        }

        static string help()
        {
            return "\nErstellungsdatum auslesen: \tchangecreated.exe -g <dateiname>" +
                "\nErstellungsdatum setzen: \tchangecreated.exe -s <dateiname> \"<datum>\"" +
                "\nErstellungsdatum übernehmen: \tchangecreated.exe -o <referenz_dateiname> <ziel_dateiname>" +
                "\n\nMit den Schaltern -ss und -os erfolgt jeweils keine Ausgabe bei der Änderung.";
        }
    }
}
